package exercise_engine;

public class EngineTest_MultipleChoice {

	public static void main(String[] args) {
		System.out.println("-->Attempt 1, Exception Thrown: ");
		attempt1(-1); System.out.println();

		System.out.println("-->Attempt 1, No Exception Thrown: ");
		attempt1(1); System.out.println();

		System.out.println("-->Attempt 2, Exception Thrown: ");
		attempt2(-1); System.out.println();

		System.out.println("-->Attempt 2, No Exception Thrown: ");
		attempt2(1); System.out.println();

		//attempt3(); System.out.println();
		
		System.out.println("-->Attempt 4 (Correct), Exception Thrown: ");
		attempt4(-1); System.out.println();
		
		System.out.println("-->Attempt 4 (Correct), No Exception Thrown: ");
		attempt4(1); System.out.println();
	
		System.out.println("-->Attempt 4b (Correct), Exception Thrown: ");
		attempt4b(-1); System.out.println();
		System.out.println("-->Attempt 4b (Correct), No Exception Thrown: ");
		attempt4b(1); System.out.println();
		
		System.out.println("-->Attempt 4c (Correct), Exception Thrown: ");
		attempt4c(-1); System.out.println();
		System.out.println("-->Attempt 4c (Correct), No Exception Thrown: ");
		attempt4c(1); System.out.println();

		System.out.println("-->Attempt 5, Exception Thrown: ");
		attempt5(-1); System.out.println();
		System.out.println("-->Attempt 5, No Exception Thrown: ");
		attempt5(1); System.out.println();
	}

	public static void attempt1(int x) {
		// correct with no exception, incorrect with exception
		Engine e = new Engine(x);

		try {
			e.init();
			e.run();
		}
		catch( RuntimeException ex ) {
			System.out.println(ex);
			e.close();
		}
		e.close();
	}

	public static void attempt2(int x) {
		// correct with no exception, incorrect with exception
		Engine e = new Engine(x);

		try {
			e.init();
			e.run();
			e.close();
		}
		catch( RuntimeException ex ) {
			System.out.println(ex);
		}
	}

	public static void attempt3(int x) {
		// doesn't compile

//		try {
//			Engine e = new Engine();
//			e.init();
//			e.run();
//			e.close();
//		}
//		catch( RuntimeException ex ) {
//			System.out.println(ex);
//		}
//		e.close();
	}

	public static void attempt4(int x) {
		// completely correct
	
		Engine e = new Engine(x);
		try {
			e.init();
			e.run();
		}
		catch( RuntimeException ex ) {
			System.out.println(ex);
		}
		e.close();
	}

	public static void attempt4b(int x) {
		Engine e = new Engine(x);
		try {
			e.init();
			e.run();
		}
		catch( RuntimeException ex ) {
			System.out.println(ex);
		}
		finally {
			e.close();
		}
	}

	public static void attempt4c(int x) {
		Engine e = new Engine(x);
		try {
			e.init();
			e.run();
			e.close();
		}
		catch( RuntimeException ex ) {
			System.out.println(ex);
			e.close();
		}
	}

	public static void attempt5(int x) {
		// incorrect with no exception, correct with exception

		Engine e = new Engine(x);
		try {
			e.init();
			e.run();
		}
		catch( RuntimeException ex ) {
			System.out.println(ex);
			e.close();
		}
	}

}